#!/usr/bin/env python
'''
Sets all port speed to 10G
'''
import sys
sys.path.append('/usr/lib/python2.7/dist-packages/python_sdk_api/')
sys.path.append('/usr/lib/python2.7/site-packages/python_sdk_api/')
sys.path.append('/usr/local/lib/python2.7/dist-packages/python_sdk_api/')
sys.path.append('/usr/local/lib/python2.7/site-packages/python_sdk_api/')

from sx_api import *

print "[+] opening sdk"
rc, handle = sx_api_open(None)
print ("sx_api_open handle:0x%x , rc %d " % (handle, rc))

if (rc != 0):
    print "Failed to open api handle.\nPlease check that SDK is running."
    exit(1)

if len(sys.argv) > 2:
    log_port = int(str(sys.argv[1]), 16)
    state = str(sys.argv[2])
else:
    print "No port given - Fetching port from SDK and setting its state to down"
    print "Usage: %s <log_port> <up|down> " % sys.argv[0]
    log_port_list_p = new_sx_port_log_id_t_arr(1)
    port_cnt_p = new_uint32_t_p()
    uint32_t_p_assign(port_cnt_p, 1)
    rc = sx_api_port_swid_port_list_get(handle, 0, log_port_list_p, port_cnt_p)
    if rc != SX_STATUS_SUCCESS:
        print "Failed to get port_list, rc %d" % rc
        sys.exit(1)

    log_port = sx_port_log_id_t_arr_getitem(log_port_list_p, 0)
    state = "down"

# Before set
oper_state_p = new_sx_port_oper_state_t_p()
admin_state_p = new_sx_port_admin_state_t_p()
module_state_p = new_sx_port_module_state_t_p()
rc = sx_api_port_state_get(handle, log_port, oper_state_p, admin_state_p, module_state_p)
if rc != 0:
    print("Error: sx_api_port_state_get returns rc:%d" % (rc))
    sys.exit(1)

oper_state = sx_port_oper_state_t_p_value(oper_state_p)
admin_state = sx_port_admin_state_t_p_value(admin_state_p)
module_state = sx_port_module_state_t_p_value(module_state_p)
print ("Before set: log_port:0x%x oper_state:%d admin state:%d module_state:%d." % (log_port, oper_state, admin_state, module_state))

state_up_down = ""
if state == "up":
    state_up_down = SX_PORT_ADMIN_STATUS_UP
elif state == "down":
    state_up_down = SX_PORT_ADMIN_STATUS_DOWN
else:
    print "Failed : the state should be up or down."
    sys.exit(1)

print "Setting port 0x%x to state %s(%d)" % (log_port, state, state_up_down)
rc = sx_api_port_state_set(handle, log_port, state_up_down)
if rc != 0:
    print("Error: sx_api_port_state_set returns rc:%d" % (rc))
    sys.exit(1)

print ("rc %d , Setting log_port:0x%x admin state to %s." % (rc, log_port, state))

rc = sx_api_port_state_get(handle, log_port, oper_state_p, admin_state_p, module_state_p)
if rc != 0:
    print("Error: sx_api_port_state_get returns rc:%d" % (rc))
    sys.exit(1)

oper_state = sx_port_oper_state_t_p_value(oper_state_p)
admin_state = sx_port_admin_state_t_p_value(admin_state_p)
module_state = sx_port_module_state_t_p_value(module_state_p)
print ("log_port:0x%x oper_state:%d admin state:%d module_state:%d." % (log_port, oper_state, admin_state, module_state))
sys.exit(0)
