#!/usr/bin/env python
'''
This is an example how to unbind/bind a port.

'''
import colorsys
import errno
import sys

from python_sdk_api.sx_api import *

print "[+] opening sdk"
rc, handle = sx_api_open(None)
print ("sx_api_open handle:0x%x , rc %d " % (handle, rc))
if (rc != SX_STATUS_SUCCESS):
    print "Failed to open api handle.\nPlease check that SDK is running."
    sys.exit(errno.EACCES)

######################################################
#    defines
######################################################
log_port = 0x10100
swid = 0

######################################################
#    examples
######################################################


def example_port_swid_bind():
    rc = sx_api_port_state_set(handle, log_port, SX_PORT_ADMIN_STATUS_DOWN)
    print ("sx_api_port_state_set  [rc=%d] " % (rc))
    if rc != SX_STATUS_SUCCESS:
        sys.exit(errno.EACCES)

    rc = sx_api_port_swid_bind_set(handle, log_port, SX_SWID_ID_DISABLED)
    print("sx_api_port_swid_bind_set unbind port 0x%x" % log_port)
    if rc != SX_STATUS_SUCCESS:
        sys.exit(errno.EACCES)

    rc = sx_api_port_swid_bind_set(handle, log_port, swid)
    print("sx_api_port_swid_bind_set bind port 0x%x to swid: %d" % (log_port, swid))
    if rc != SX_STATUS_SUCCESS:
        sys.exit(errno.EACCES)

    return

######################################################
#    main
######################################################


def main():
    example_port_swid_bind()


if __name__ == "__main__":
    main()

sx_api_close(handle)
