#!/usr/bin/env python
'''
This an example how to add/delete VLAN.
'''

import errno
import sys
import colorsys

from python_sdk_api.sx_api import *
from test_infra_common import *

print "[+] opening sdk"
rc, handle = sx_api_open(None)
print ("sx_api_open handle:0x%x , rc %d " % (handle, rc))
if (rc != SX_STATUS_SUCCESS):
    print ("Failed to open api handle.\nPlease check that SDK is running.")
    sys.exit(errno.EACCES)

swid = 0
vlan_id = 100

cmd = SX_ACCESS_CMD_DELETE

vlan_list_p = new_sx_vlan_id_t_p()
sx_vlan_id_t_p_assign(vlan_list_p, vlan_id)

# get number of VLANs
data_cnt_p = new_uint32_t_p()
uint32_t_p_assign(data_cnt_p, 0)

rc = sx_api_vlan_get(handle, swid, vlan_list_p, data_cnt_p)
if rc != SX_STATUS_SUCCESS:
    print ("sx_api_port_vlan_get failed, rc=[%d] " % (rc))
    sys.exit(errno.EACCES)
print ("Successfully got %d VLANs" % (uint32_t_p_value(data_cnt_p)))

# add/delete VLAN
uint32_t_p_assign(data_cnt_p, 1)

rc = sx_api_vlan_set(handle, cmd, swid, vlan_list_p, data_cnt_p)
if rc != SX_STATUS_SUCCESS:
    print ("sx_api_port_vlan_set failed, rc=[%d], cmd=[%d] " % (rc, cmd))
    sys.exit(errno.EACCES)

print ("VLAN %d was successfully deleted" % (vlan_id))

# get number of VLANs
uint32_t_p_assign(data_cnt_p, 0)

rc = sx_api_vlan_get(handle, swid, vlan_list_p, data_cnt_p)
if rc != SX_STATUS_SUCCESS:
    print ("sx_api_port_vlan_get failed, rc=[%d] " % (rc))
    sys.exit(errno.EACCES)
print ("Successfully got %d VLANs" % (uint32_t_p_value(data_cnt_p)))

# add/delete VLAN
uint32_t_p_assign(data_cnt_p, 1)
cmd = SX_ACCESS_CMD_ADD

rc = sx_api_vlan_set(handle, cmd, swid, vlan_list_p, data_cnt_p)
if rc != SX_STATUS_SUCCESS:
    print ("sx_api_port_vlan_set failed, rc=[%d], cmd=[%d] " % (rc, cmd))
    sys.exit(errno.EACCES)

print ("VLAN %d was successfully added" % (vlan_id))

# get number of VLANs
uint32_t_p_assign(data_cnt_p, 0)

rc = sx_api_vlan_get(handle, swid, vlan_list_p, data_cnt_p)
if rc != SX_STATUS_SUCCESS:
    print ("sx_api_port_vlan_get failed, rc=[%d] " % (rc))
    sys.exit(errno.EACCES)
print ("Successfully got %d VLANs" % (uint32_t_p_value(data_cnt_p)))

sx_api_close(handle)
