#!/usr/bin/env python
'''
Python commands syntax is very similar to the Switch SDK APIs.
You can learn more about each command and its parameters by reading the SwitchX API Reference Manual.

This utility resets the module
'''
import sys
import errno
import argparse
from python_sdk_api.sx_api import *
from test_infra_common import *
import python_sdk_api.sx_api as sx_api

def mgmt_phy_mod_reset(handle, module_id):
    rc = sx_mgmt_phy_mod_reset(handle, module_id)
    assert SX_STATUS_SUCCESS == rc, "mgmt_phy_mod_reset failed"


def parse_example_attributes():
    parser = argparse.ArgumentParser(description='Module reset utility')
    parser.add_argument('--module_id', type=int, help="Module id", required=True)
    args = parser.parse_args()

    if len(sys.argv) < 2:
        print "Usage:"
        print "Example: Module Reset sx_mgmt_module_reset.py --module_id 1"
        sys.exit(0)

    module_id = args.module_id
    return module_id

################################################
# Run the MAIN function
################################################
if __name__ == "__main__":

    module_id  = parse_example_attributes()
    print "[+] opening sdk"
    rc, handle = sx_api_open(None)
    print ("sx_api_open handle:0x%x , rc %d " % (handle, rc))
    if (rc != SX_STATUS_SUCCESS):
        print "Failed to open api handle.\nPlease check that SDK is running."
        sys.exit(errno.EACCES)

    # construct the port module map.
    ports_attributes_list = ports_attributes_get(handle)
    port_module_map, module_port_map = get_port_module_mapping(ports_attributes_list, len(ports_attributes_list))

    if module_id not in module_port_map.keys():
        print("Error: Invalid Module Id")
        sys.exit(0)

    mgmt_phy_mod_reset(handle, module_id);
    print "Reset executed for module [%d]" %(module_id)

    sx_api_close(handle)
