#!/usr/bin/env python

import sys
import errno
import time
import os
from python_sdk_api.sxd_api import *

print "[+] initializing register access"
rc = sxd_access_reg_init(0, None, 4)
if (rc != 0):
    print "Failed to initializing register access.\nPlease check that SDK is running."
    sys.exit(errno.EACCES)

print "[+] reading SBIB register"
sbib = ku_sbib_reg()
sbib.type = 0
sbib.int_buff_index = 0

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0

""" Set port buff size """
print "[+] SET SBIB PORT #3 "
meta.access_cmd = SXD_ACCESS_CMD_SET
sbib.local_port = 0x21
sbib.buff_size = 240
"""sbib.buff_size = 0"""
"""sxd_access_reg_sbib(sbib, meta, 1, None, None)"""

""" Get max port number for the device """
meta.access_cmd = SXD_ACCESS_CMD_GET

rsrc = ku_query_rsrc()
rsrc.rsrc_id = KU_RES_ID_CAP_MAX_SWITCH_PORTS

sxd_access_reg_query_rsrc_info(rsrc)

MIN_PORT = 1
MAX_PORT = rsrc.rsrc_val


""" Get all port buff size for those ports whic hare enabled """
pspa = ku_pspa_reg()

for local_port in xrange(MIN_PORT, MAX_PORT):
    meta.swid = 0
    pspa.swid = 0
    pspa.sub_port = 0
    pspa.local_port = local_port

    sxd_access_reg_pspa(pspa, meta, 1, None, None)

    if pspa.swid == 0xFF:
        # swid (0xFF) is disabled port
        continue

    sbib.local_port = local_port

    sxd_access_reg_sbib(sbib, meta, 1, None, None)
    print "P# ", sbib.local_port, ": Buff_size = ", sbib.buff_size
