#!/usr/bin/env python
from python_sdk_api.sx_api import *
import socket
import struct


import sys
import errno
import time
import os
import argparse
from python_sdk_api.sxd_api import *

print "[+] initializing register access"
rc = sxd_access_reg_init(0, None, 4)
if (rc != 0):
    print "Failed to initializing register access.\nPlease check that SDK is running."
    sys.exit(errno.EACCES)

print "[+] Reading SMID register:"
parser = argparse.ArgumentParser(description='SMID read utility')
parser.add_argument('--mid', default=1, type=int, help="MID")
args = parser.parse_args()

if len(sys.argv) < 3:
    print "******************************************************"
    print "!! MID parameter should be retrieved from Debug CLI !!"
    print "Use the following command get the MID from FID:"
    print "sx_debug_cmd_client fdb flood vector get <FID#>"
    print "Example: ./sxd_api_smid.py --mid 100"
    print "******************************************************\n"
    sys.exit(0)

smid = ku_smid_reg()
smid.mid = args.mid
smid.swid = 0

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0
meta.access_cmd = SXD_ACCESS_CMD_GET

sxd_access_reg_smid(smid, meta, 1, None, None)

print "Swid: ", smid.swid
print "mid: ", smid.mid
print "Ports list: "

port_flag = 0
for index in xrange(0, 256):
    port = uint16_t_arr_getitem(smid.ports_bitmap, index)
    if port == 1:
        port_flag = 1
        print "[" + str(index) + "]"

if port_flag == 0:
    print "* Port list is empty"

print "Opcode: ", smid.op
print "Smpe_valid: ", smid.smpe_valid
print "Smpe: ", smid.smpe

