#!/usr/bin/env python

import sys
import time
import os
from python_sdk_api.sxd_api import *

print "[+] MONI register access Example Test start"
print "[+] initializing register access"
sxd_access_reg_init(0, None, 4)

moni = ku_moni_reg()

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0

meta.access_cmd = SXD_ACCESS_CMD_GET

# find valid local port for the current device
pspa = ku_pspa_reg()
for local_port in range(1, 64):
    meta.swid = 0
    pspa.swid = 0
    pspa.sub_port = 0
    pspa.local_port = local_port

    sxd_access_reg_pspa(pspa, meta, 1, None, None)

    if pspa.swid != 0xFF:
        break

print("[+] For the exaple we will use local port %d" % (pspa.local_port))
moni.local_port = pspa.local_port

print "[+] Get MONI"
rc = sxd_access_reg_moni(moni, meta, 1, None, None)
assert rc == 0, "Failed to read MONI register, rc: %d" % (rc)

print "[+] Get MONI content"
print "===================="
print "[+] local port: ", moni.local_port
print "[+] en:", moni.en

meta.access_cmd = SXD_ACCESS_CMD_SET

moni.en = 1

print "[+] Set MONI content"
print "===================="
print "[+] en:", moni.en

print "[+] Set MONI "

sxd_access_reg_moni(moni, meta, 1, None, None)

meta.access_cmd = SXD_ACCESS_CMD_GET

print "[+] Get MONI"
sxd_access_reg_moni(moni, meta, 1, None, None)

print "[+] Get after Set MONI content"
print "===================="
print "[+] local port: ", moni.local_port
print "[+] en:", moni.en

moni.local_port = pspa.local_port
print "[+] Get MONI for another local port"
sxd_access_reg_moni(moni, meta, 1, None, None)
print "[+] Verify MONI bit is NOT set"
print "===================="
print "[+] local port: ", moni.local_port
print "[+] en:", moni.en

print "[+] MONI register access example test end"
