#!/usr/bin/env python

import sys
import time
import os
from python_sdk_api.sxd_api import *

print "[+] MPGCR register access test start"
print "[+] initializing register access"
sxd_access_reg_init(0, None, 4)

mpgcr = ku_mpgcr_reg()

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0

meta.access_cmd = SXD_ACCESS_CMD_GET

print "[+] Get MPGCR"
sxd_access_reg_mpgcr(mpgcr, meta, 1, None, None)

print "[+] Get MPGCR content"
print "===================="
print "[+] mpls_et:", mpgcr.mpls_et
print "[+] mpls_pcp_rw:", mpgcr.mpls_pcp_rw
print "[+] ler_exp_rw:", mpgcr.ler_exp_rw
print "[+] ingress_ler_ttl:", mpgcr.ingress_ler_ttl
print "[+] egress_ler_ttl:", mpgcr.egress_ler_ttl
print "[+] lsr_egress_ttl:", mpgcr.lsr_egress_ttl
print "[+] ingress_ler_ttl_value:", mpgcr.ingress_ler_ttl_value
print "[+] hrlsn:", mpgcr.hrlsn
print "[+] label_id_min:", mpgcr.label_id_min
print "[+] label_id_max:", mpgcr.label_id_max
print "[+] entropy_msb:", mpgcr.entropy_msb
print "[+] activity_dis_mpnhlfe:", mpgcr.activity_dis_mpnhlfe

meta.access_cmd = SXD_ACCESS_CMD_SET

mpgcr.mpls_et = 3
mpgcr.mpls_pcp_rw = 0
mpgcr.ler_exp_rw = 2
mpgcr.ingress_ler_ttl = 1
mpgcr.egress_ler_ttl = 0
mpgcr.lsr_egress_ttl = 1
mpgcr.ingress_ler_ttl_value = 64
mpgcr.hrlsn = 31
mpgcr.label_id_min = 32
mpgcr.label_id_max = 0xfffff
mpgcr.entropy_msb = 0
mpgcr.activity_dis_mpnhlfe = 0

print "[+] Set MPGCR content"
print "===================="
print "[+] mpls_et:", mpgcr.mpls_et
print "[+] mpls_pcp_rw:", mpgcr.mpls_pcp_rw
print "[+] ler_exp_rw:", mpgcr.ler_exp_rw
print "[+] ingress_ler_ttl:", mpgcr.ingress_ler_ttl
print "[+] egress_ler_ttl:", mpgcr.egress_ler_ttl
print "[+] lsr_egress_ttl:", mpgcr.lsr_egress_ttl
print "[+] ingress_ler_ttl_value:", mpgcr.ingress_ler_ttl_value
print "[+] hrlsn:", mpgcr.hrlsn
print "[+] label_id_min:", mpgcr.label_id_min
print "[+] label_id_max:", mpgcr.label_id_max
print "[+] entropy_msb:", mpgcr.entropy_msb
print "[+] activity_dis_mpnhlfe:", mpgcr.activity_dis_mpnhlfe

print "[+] Set MPGCR "

sxd_access_reg_mpgcr(mpgcr, meta, 1, None, None)

meta.access_cmd = SXD_ACCESS_CMD_GET

print "[+] Get MPGCR"
sxd_access_reg_mpgcr(mpgcr, meta, 1, None, None)

print "[+] Get after Set MPGCR content"
print "===================="
print "[+] mpls_et:", mpgcr.mpls_et
print "[+] mpls_pcp_rw:", mpgcr.mpls_pcp_rw
print "[+] ler_exp_rw:", mpgcr.ler_exp_rw
print "[+] ingress_ler_ttl:", mpgcr.ingress_ler_ttl
print "[+] egress_ler_ttl:", mpgcr.egress_ler_ttl
print "[+] lsr_egress_ttl:", mpgcr.lsr_egress_ttl
print "[+] ingress_ler_ttl_value:", mpgcr.ingress_ler_ttl_value
print "[+] hrlsn:", mpgcr.hrlsn
print "[+] label_id_min:", mpgcr.label_id_min
print "[+] label_id_max:", mpgcr.label_id_max
print "[+] entropy_msb:", mpgcr.entropy_msb
print "[+] activity_dis_mpnhlfe:", mpgcr.activity_dis_mpnhlfe


print "[+] MPGCR register access test end"
