#!/usr/bin/env python

import sys
import errno


import sys
import time
import os
from test_infra_common import *
from python_sdk_api.sxd_api import *
import sxd_api_chip_type_rev_get as sxd_api_chip_type

admin_dict = {0: 'NONE', 1: 'UP', 2: 'DOWN', 3: 'UP_ONCE'}
oper_dict = {0: 'NONE', 1: 'UP', 2: 'DOWN', 4: 'DOWN_BY_FAIL'}

print "[+] paos register access test start"

print "[+] get port number"
port_num = 0
port_num_max = 128
port_attributes_list = new_sx_port_attributes_t_arr(port_num_max)
port_cnt_p = new_uint32_t_p()
uint32_t_p_assign(port_cnt_p, port_num_max)

rc, handle = sx_api_open(None)

rc = sx_api_port_device_get(handle, 1, 0, port_attributes_list, port_cnt_p)
port_cnt = uint32_t_p_value(port_cnt_p)
if (rc != 0):
    print "An error was found in sx_api_port_device_get.\nThe example will exit"
    exit()
for i in range(0, port_cnt):
    port_attributes = sx_port_attributes_t_arr_getitem(port_attributes_list, i)
    is_vport = check_vport(int(port_attributes.log_port))
    is_nve = check_nve(int(port_attributes.log_port))
    is_cpu = check_cpu(int(port_attributes.log_port))
    if is_nve or is_vport or is_cpu:
        continue
    else:
        port_num = port_attributes.port_mapping.local_port
        break

print "[+] initializing register access"
sxd_access_reg_init(0, None, 4)

paos = ku_paos_reg()

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0

meta.access_cmd = SXD_ACCESS_CMD_GET

paos.local_port = port_num
paos.admin_status = 0
paos.ase = 0
paos.e = 0
paos.ee = 0
paos.oper_status = 0
paos.swid = 0


print "[+] Get paos\n"
sxd_access_reg_paos(paos, meta, 1, None, None)
print ("[+] Port admin_status is %s" % admin_dict[paos.admin_status])
print ("[+] Port oper_status is %s\n" % oper_dict[paos.oper_status])


print "[+] Set paos\n"
paos.ase = 1
save_admin_status = paos.admin_status
meta.access_cmd = SXD_ACCESS_CMD_SET
if paos.admin_status == 1 or paos.admin_status == 3:
    paos.admin_status = 2
else:
    paos.admin_status = 1
sxd_access_reg_paos(paos, meta, 1, None, None)
print ("[+] Port admin_status is %s" % admin_dict[paos.admin_status])
print ("[+] Port oper_status is %s\n" % oper_dict[paos.oper_status])


print "[+] Restore paos\n"
paos.admin_status = save_admin_status
meta.access_cmd = SXD_ACCESS_CMD_SET
sxd_access_reg_paos(paos, meta, 1, None, None)
print ("[+] Port admin_status is %s" % admin_dict[paos.admin_status])
print ("[+] Port oper_status is %s\n" % oper_dict[paos.oper_status])

sx_api_close(handle)
