#!/usr/bin/env python

lbf_mode_dict = {0: 'NO_CHANGE', 1: 'DISABLED', 2: 'ENABLED'}


import sys
import time
import os
from python_sdk_api.sxd_api import *

print "[+] PLBF (Port Looback Filter Register) register access test start"
print "[+] initializing register access"
rc = sxd_access_reg_init(0, None, 4)
if (rc != 0):
    print "Failed to initializing register access.\nPlease check that SDK is running."
    sys.exit(errno.EACCES)

plbf = ku_plbf_reg()
plbf.lbf_mode = 0

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0
meta.access_cmd = SXD_ACCESS_CMD_GET

"""
Set the locat port here. Please make sure this is not the panel port.
In order to get the right mapping please use the sx_api_ports_dump utility.
"""
plbf.port = 1


print
print "[+] Get PLBF"
sxd_access_reg_plbf(plbf, meta, 1, None, None)


print "[+] Get PLBF content"
print "===================="
print "[+] local port: ", plbf.port
print "[+] Loopback filter state: ", lbf_mode_dict[plbf.lbf_mode]

meta.access_cmd = SXD_ACCESS_CMD_SET

"""
See the lbf_mode_dict dictionary above for all the available options
"""

plbf.lbf_mode = plbf.lbf_mode % 2 + 1

print
print "[+] Set PLBF content"
print "===================="
print "[+] local port: ", plbf.port
print "[+] Loopback filter state: ", lbf_mode_dict[plbf.lbf_mode]

print "[+] Set PLBF"
sxd_access_reg_plbf(plbf, meta, 1, None, None)


meta.access_cmd = SXD_ACCESS_CMD_GET
plbf.lbf_mode = 0

print
print "[+] Get PLBF after the set operation was done"
sxd_access_reg_plbf(plbf, meta, 1, None, None)

print "[+] Get PLBF content"
print "===================="
print "[+] local port: ", plbf.port
print "[+] Loopback filter state: ", lbf_mode_dict[plbf.lbf_mode]

print "[+] PLBF register access test end"
