#!/usr/bin/env python

import sys
import time
import os
import argparse
import errno
from python_sdk_api.sxd_api import *

print "[+] Set/Get PPLR register access example"

parser = argparse.ArgumentParser(description='PPLR get/set example')
parser.add_argument('--cmd', default=0, type=int, help="GET(0), SET(1)")
parser.add_argument('--local_port', default=1, type=int, help="Local Port")
parser.add_argument('--egress_lpbk', default=1, type=int, help="Disable(0), Enable(1)")
parser.add_argument('--ingress_lpbk', default=1, type=int, help="Disable(0), Enable(1)")
parser.add_argument('--port_type', default=0, type=int, help="0-default 1-near-end; 2-internal IC LR; 3-far-end; 4-usr main; 5-usr tile")
args = parser.parse_args()

if len(sys.argv) < 7:
    print "Example: GET: ./sxd_api_pplr_setget.py --cmd 0 --local_port 1 --port_type 0"
    print "         SET: ./sxd_api_pplr_setget.py --cmd 1 --local_port 1 --egress_lpbk 1 --port_type 2"
    sys.exit(0)

print "[+] initializing register access"
rc = sxd_access_reg_init(0, None, 4)
if (rc != 0):
    print "Failed to initialize register access.\nPlease check that SDK is running."
    sys.exit(errno.EACCES)

pplr = ku_pplr_reg()

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0

meta.access_cmd = SXD_ACCESS_CMD_GET
pplr.local_port = args.local_port
pplr.port_type = args.port_type

print "===================="
print "[+] Get PPLR"
print "[+] local port : ", pplr.local_port
print "[+] port_type : ", pplr.port_type
rc=sxd_access_reg_pplr(pplr, meta, 1, None, None)
print "[+] Get PPLR done. rc:",rc
print "[+] local_port : ", pplr.local_port
print "[+] port_type : ", pplr.port_type
print "[+] el : ", pplr.el
print "[+] il : ", pplr.il

if args.cmd != 1:
    sys.exit(0)

meta.access_cmd = SXD_ACCESS_CMD_SET
pplr.local_port = args.local_port
pplr.port_type = args.port_type
pplr.el = args.egress_lpbk
pplr.il = args.ingress_lpbk

print "===================="
print "[+] Set PPLR"
print "[+] local_port : ", pplr.local_port
print "[+] port_type : ", pplr.port_type
print "[+] el: ", pplr.el
print "[+] il : ", pplr.il
rc=sxd_access_reg_pplr(pplr, meta, 1, None, None)
print "[+] Set PPLR done. rc:",rc

meta.access_cmd = SXD_ACCESS_CMD_GET
pplr.local_port = args.local_port
pplr.port_type = args.port_type

print "===================="
print "[+] Get PPLR"
print "[+] local_port : ", pplr.local_port
print "[+] port_type : ", pplr.port_type
rc=sxd_access_reg_pplr(pplr, meta, 1, None, None)
print "[+] Get PPLR done. rc:",rc
print "[+] local_port : ", pplr.local_port
print "[+] port_type : ", pplr.port_type
print "[+] el : ", pplr.el
print "[+] il : ", pplr.il
print "[+] PPLR register example end"

